var curProjectFile = '';

function uzLoadCurrentProject() {
  window._content.document.location = 'chrome://uzreview/content/report/index.html?file=' +curProjectFile;
}

function loadReview(dataPath) {
	curProjectFile = dataPath;
  var reviewFile = new File(dataPath);
  debugDump("Review " + reviewFile.exists() + "\n");
  reviewFile.open("r");
  reviewXML = reviewFile.read();
  reviewFile.close();
    debugDump(reviewXML + "\n\n");
  return (new DOMParser().parseFromString(reviewXML, "text/xml"));
}

// Called from intro screen as well as browse screens to switch mode
// to run.
// DEPENDENCIES: Relys on loaded xHeuristics file.
function resumeProject(loaded) {
	var projectNode;
  document.getElementById("heuristicTopDeck").setAttribute("selectedIndex", 1);
  deleteAllChilds(document.getElementById("project-selector"));
		
	uzPopulateSelector();

  // with multiple heuristic files, may need to refresh with each project
	//if(!heuristicsXML) {		
		//heuristicsInit();
		debugDump(">>uzREview: reinitializing heuristics for resume \n");
		projectNode = xHeuristics.getElementsByTagName("project").item(0);
		var du=new DirUtils(); 
		var dataPath = du.getChromeDir() + '\\uzreview\\content\\heuristics\\' + projectNode.getAttribute('heuristicset') + '.xml';
  	var dataFile = new File(dataPath);
  	debugDump("Found datafile? " + dataPath + " "+ dataFile.exists() + "\n");
  	dataFile.open("r");
  	var heuristicXMLfile = dataFile.read();
  	dataFile.close;
  	// Object for UI population of heuristics
  	heuristicsXML =  new DOMParser().parseFromString(heuristicXMLfile, "text/xml");
 		
	//}
	deleteAllChilds(document.getElementById("heuristic-holder"));
	populateHeuristicsForm(heuristicsXML);
	
  reviewStarted = true;

}

// Clears project name/owner as well as project list and projectview panes
function uzResetUI() {
	document.getElementById("heuristic_project_name").value="";
	document.getElementById("heuristic_project_owner").value="";
	deleteAllChilds(document.getElementById("project-selector"));
	deleteAllChilds(document.getElementById("view-page-holder"));
	deleteAllChilds(document.getElementById("view-heuristic-holder"));
	//document.getElementById("id_keyword").selected = "false";	
	//document.getElementById("id_url").selected = "true";
	document.getElementById("uzMode").selectedItem = document.getElementById("id_url");
}

// Called from Project View "Close"
function reInitialize() {
	document.getElementById("heuristicTopDeck").setAttribute("selectedIndex", 0);
	reviewStarted = false;
	uzResetUI();
	inited=false;
	uzPopulateSelector();
	
}

// Arguments: takes a flag indicating whether xHeuristics is already loaded;
function viewReview(loaded) {

		
	if(!loaded) {
  	var du=new DirUtils(); 
  	var reviewNode = document.getElementById("project-selector").selectedItem;
		debugDump("resuming and setting from "+ reviewNode.getAttribute("label") + "\n");
  	debugDump("Loading review" + reviewNode.getAttribute("path") + "\n");
  	var dataPath =  reviewNode.getAttribute("path") ;
  	xHeuristics = loadReview(dataPath);
		// Two name headers in UI
		document.getElementById('heuristic_name').setAttribute( 'value',reviewNode.getAttribute("label"));
		document.getElementById('heuristic_name_pview').setAttribute( 'value',reviewNode.getAttribute("label"));
		document.getElementById("heuristic_keyword").value ="";
	} else {
		// Has this project been saved yet?
		// If not, the view by will be empty
		dump("Viewing already loaded review\n");
		// Save on run->browse mode switch
		commitReview();
		// Turn off progress listener	
		getBrowser().removeProgressListener(urProgressListener);
	}

	
 	// Refreshing the widgetry is cheap.
	// Let's just do it across the board.
	// TODO: Add a review-dirty flag
	deleteAllChilds(document.getElementById("view-page-holder"));
	deleteAllChilds(document.getElementById("view-heuristic-holder"));
	deleteAllChilds(document.getElementById("heuristic_keyword").childNodes.item(0)); // remove menuitems from childnode menupopup
	
	viewPopulatePages(xHeuristics);
	viewPopulateHeuristics(xHeuristics);
	populateKeywordMenu(xHeuristics);

	// Need to load comments
	//loadComments(dataPath.replace(".xml", ".html"));

  //document.getElementById('heuristicTopDeck').selectedIndex=1;
  document.getElementById("heuristicTopDeck").setAttribute("selectedIndex", 2);
  debugDump("Swapped deck " + document.getElementById("heuristicTopDeck").getAttribute("selectedIndex"));
}

function loadComments(filePath) {
	var comments = new File(filePath);
  comments.open("r");
  commentsHTML = comments.read();
	debugDump("Read comments " + comments.length + "\n");
  comments.close();
	document.getElementById('edit-box').contentWindow.document.body.innerHTML = commentsHTML;
}
// Browse widget
function viewPopulatePages(xml) {
  var pages = xml.getElementsByTagName("page");
  var pageHolder = document.getElementById("view-page-holder");
  var tempNode;
  debugDump("Found " + pages.length + " page entries\n","projectview");
  for(var i=0; i< pages.length; i++) {
		//debugDump(i + " " + pages.item(i).parentNode.nodeName + "\n");
		//debugDump("working with " + pages.item(i).getAttribute("url") + " of " + pages.item(i).parentNode.nodeName + "\n");
		if(pages.item(i).parentNode.nodeName == "uzreviewdata") {
    tempNode = document.createElement("listitem");
		if(pages.item(i).hasAttribute("title") && pages.item(i).getAttribute("title").length) {
    	tempNode.setAttribute("label", pages.item(i).getAttribute("title"));
		} else {
			tempNode.setAttribute("label", trimUrl(pages.item(i).getAttribute("url")));
		}
    //tempNode.setAttribute("tooltiptext", trimUrl(pages.item(i).getAttribute("url")));
		tempNode.setAttribute("url", pages.item(i).getAttribute("url"));
		tempNode.setAttribute("type", "page");		
		tempNode.setAttribute("offset", i);
		debugDump(tempNode + "\n");
    pageHolder.appendChild(tempNode);
		pageHolder.addEventListener("mouseup", uzViewElement, false);
		}
  }
	pages = xml.getElementsByTagName("keyword");
	debugDump("Found " + pages.length + " keyword entries\n");
  for(var i=0; i< pages.length; i++) {
		debugDump("keyword " + i + " wroking with " + pages.item(i).getAttribute("id") + "\n");
	  tempNode = document.createElement("listitem");
    tempNode.setAttribute("label", trimUrl(pages.item(i).getAttribute("id")));
    tempNode.setAttribute("tooltiptext", trimUrl(pages.item(i).getAttribute("id")));
		tempNode.setAttribute("id", pages.item(i).getAttribute("id"));
		tempNode.setAttribute("type", "keyword");		
		tempNode.setAttribute("offset", i);
    pageHolder.appendChild(tempNode);
		pageHolder.addEventListener("mouseup", uzViewElement, false);
	}
}

// Browse widget
function viewPopulateHeuristics(xml) {
  var heuristics =xml.getElementsByTagName("heuristic");
  var heuristicHolder = document.getElementById("view-heuristic-holder");
  var tempNode;
  debugDump(">>uzReview: Heuristics view. Found " + heuristics.length + " url entries, appending to " + heuristicHolder.nodeName + "\n");
	// Bug 4345, http://mozdev.org/bugs/show_bug.cgi?id=4345
  for(var i=0; i< heuristics.length; i++) {
    tempNode = document.createElement("listitem");
		// Associative array the id to the full heuristic name.
    tempNode.setAttribute("label", heuristics.item(i).getAttribute("id"));
		tempNode.setAttribute("url", heuristics.item(i).getAttribute("url"));		
		tempNode.setAttribute("type", "heuristic");		
		tempNode.setAttribute("offset", i);
    heuristicHolder.appendChild(tempNode);
		heuristicHolder.addEventListener("mouseup", uzViewElement, false);
  }
}

// Initiates load of a project 
function uzViewElement(evt) {
	var xmlNodes, xmlNode;
	var startUrl=false;
	var evtNode = evt.target;
	if(evtNode.getAttribute("type") == "heuristic") {
		debugDump("Resuming on heuristic with " + evtNode.nodeName + " and offset " + evtNode.getAttribute("offset") +"\n");
		xmlNodes = xHeuristics.getElementsByTagName("heuristic");
		dump("xmlNode " + xmlNodes.length + "\n");
		xmlNode = xmlNodes.item(evtNode.getAttribute("offset"));
		dump("got xmlNode " + xmlNode.nodeName + "\n");
		dump("parent page node is " + xmlNode.parentNode.nodeName + "\n");
		curLoc = xmlNode.parentNode.getAttribute("url");
		dump("new loc is " + curLoc + "\n");
		document.getElementById("heuristic_url").value= trimUrl(curLoc); 
		document.getElementById("heuristic_url").setAttribute("url", curLoc);  
  	document.getElementById("heuristic_url").setAttribute("tooltiptext", curLoc);
		uzInKeyword = false;
		resumeProject(true);
		heuristicsLoggedOnPage = false;
		exampleLoggedOnPage = false;
		addPageChangeListener();
		getBrowser().contentDocument.location = curLoc;
	} else {
		if(evtNode.getAttribute("type") == "page") {
			debugDump("Resuming on page\n");

			xmlNode = xHeuristics.getElementsByTagName("page").item(evtNode.getAttribute("offset"));	
			startUrl = evtNode.getAttribute("url");
			uzInKeyword = false;
			curLoc = startUrl;
			document.getElementById("heuristic_url").value= trimUrl(curLoc); 
			document.getElementById("heuristic_url").setAttribute("url", curLoc);  
  		document.getElementById("heuristic_url").setAttribute("tooltiptext", curLoc);
			document.getElementById("uzMode").selectedItem = document.getElementById("id_url");
			resumeProject(true);
			heuristicsLoggedOnPage = false;
			exampleLoggedOnPage = false;
			addPageChangeListener();
			getBrowser().contentDocument.location = startUrl;
		} else {
			// It's a keyword
			debugDump("Resuming on keyword\n");

			xmlNode = xHeuristics.getElementsByTagName("keyword").item(evtNode.getAttribute("offset"));
			document.getElementById("heuristic_keyword").value = xmlNode.getAttribute("id");
			document.getElementById("id_keyword").disabled = false;
			//document.getElementById("uzMode").setAttribute("selectedIndex", 1);
			document.getElementById("uzMode").selectedItem = document.getElementById("id_keyword");
			uzInKeyword = xmlNode.getAttribute("id");
			resumeProject(true);
			uzLoadExisting();
			addPageChangeListener();
		}
	}
	
	
}

